﻿using Domain;

namespace Presenter {
	public class SpawnRose {
		private readonly Score _score;
		private readonly IRoseSpawner _spawner;

		public SpawnRose(Score score, IRoseSpawner spawner) {
			_score = score;
			_spawner = spawner;
		}

		public void Execute() {
			if(_score.Roses > Score.InitialRosesThreshold)
				_spawner.SpawnRose();
			else
				_spawner.SpawnInitialRose();
		}
	}
}