﻿using System;
using Pooling;
using Presenter;
using UnityEngine;
using UnityEngine.Serialization;
using Animation = FramedAnimator.Animation;
using Animator = FramedAnimator.Animator;

namespace View.Scene {
	public class GrowParticle : MonoBehaviour, IPooledObject {
		[SerializeField] private Animator animator;
		[SerializeField] private Animation particleAnimation;

		public void OnObjectSpawn() {
			animator.ChangeAnimation(particleAnimation);
			animator.OnAnimationEnd += _ => Pooler.Recycle(gameObject);
			animator.PlayUntil(1f);
		}
	}
}